property myTargetMovie

on getBehaviorDescription me
  return "PLAY MOVIE X" & RETURN & RETURN & "Drop this behavior onto a Sprite, the Stage or into the Script Channel of the Score to start a sequence and move the playback head to a given movie." & RETURN & RETURN & "Use the 'Play Done' behavior to end the sequence and to tell the playback head to return to the current frame." & RETURN & RETURN & "PARAMETERS:" & RETURN & "* Play which movie on mouseUp?" & RETURN & RETURN & "If the target movie is in the same folder as the current movie then you need only enter the name of the movie. " & "If the movie is in a different folder, then enter the full or relative path name to the target movie." & RETURN & RETURN & "ASSOCIATED BEHAVIORS:" & RETURN & "+ Play Frame X" & RETURN & "+ Play Done"
end

on getBehaviorTooltip me
  return "Use with graphic members or as a frame behavior. " & "Jumps the playback head to the given movie. " & "Acts on mouseUp or on exitFrame, depending on whether you drag it to a sprite or to the Stage. " & "Use the Play Done behavior to return to this frame."
end

on mouseUp me
  play movie myTargetMovie
end

on exitFrame me
  if the currentSpriteNum = 0 then
    play movie myTargetMovie
  end if
end

on isOKToAttach me, aSpriteType, aSpriteNum
  return 1
end

on getPropertyDescriptionList me
  if the currentSpriteNum = 0 then
    theComment = "Play which movie on exitFrame?"
  else
    theComment = "Play which movie on mouseUp?"
  end if
  theComment = theComment & RETURN & "(Include path if necessary)."
  return [#myTargetMovie: [#comment: theComment, #format: #string, #default: "Type the name of your movie here"]]
end
